<template>
    <div v-if="profile">
        <div class="profile-container">
            <bit-header showBack :title="profile.name" :desc="profile.species">
                <button class="request-button" v-if="profile" :disabled="!isAlive" @click="sendRequest()"
                    :title="isAlive ? 'Send a friend request to this character' : 'Dead character cannot receive requests'">Send
                    request</button>
            </bit-header>
            <div v-if="showSuccess" class="alert alert-success" role="alert">
                Request sucessfully sended!
            </div>
            <div class="content">
                <img class="profile" :src=profile.image :alt=profile.name>
                <div class="texts-container">
                    <div class="quote-container">
                        <img class="quote" :src="require('@/assets/images/Quote-1.svg')" alt="Open quote image">
                        <h3>{{ mockQuote }}</h3>
                        <img class="quote" :src="require('@/assets/images/Quote-2.svg')" alt="Close quote image">
                    </div>
                    <p>
                        Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed pulvinar tincidunt est vitae dignissim.
                        Nunc sed turpis vel libero aliquam aliquet aliquam nec tellus. Nullam pharetra lacinia aliquet.
                        Nullam vel dignissim eros. Donec hendrerit nulla odio, non tempus sem bibendum in. Pellentesque
                        maximus erat in scelerisque pellentesque. Phasellus eu vulputate lorem. Aliquam rutrum mollis mi,
                        quis vestibulum massa convallis eget. Suspendisse leo urna, dignissim quis placerat ac, mollis
                        tincidunt magna. Ut scelerisque, neque a pulvinar tempor, ligula lacus semper tellus, et auctor ante
                        eros vel nibh. Ut malesuada, justo et ullamcorper volutpat, orci ipsum egestas quam, ac consectetur
                        mauris risus in arcu. Vestibulum in lacus cursus turpis consectetur euismod. Nulla purus nisl,
                        semper mollis justo vel, consectetur venenatis tellus.</p>
                </div>
            </div>
        </div>
    </div>
    <bit-spinner v-else></bit-spinner>
</template>

<script>

import { defineComponent, ref, computed } from "vue";
import BitHeader from './BitHeader.vue';
import BitSpinner from './BitSpinner.vue'
import axios from 'axios';
import { useRoute } from 'vue-router';

export default defineComponent({
    name: 'Profile',
    components: {
        BitHeader,
        BitSpinner
    },
    setup() {
        const route = useRoute();
        const id = route.path.split('/').pop();
        const profile = ref();
        axios.get(`https://rickandmortyapi.com/api/character/${id}`).then(response => {
            profile.value = response.data
        });
        const sendRequest = () => {
            showSuccess.value = true
            const hideMessageTimout = setTimeout(() => {
                showSuccess.value = false;
                clearTimeout(hideMessageTimout);
            }, 2500);
        }

        const showSuccess = ref(false);

        const isAlive = computed(() => {
            return profile.value.status === 'Alive'
        })
        const mockQuote = computed(() => {
            return `${profile.value.name} ${profile.value.species} est!!!`;
        });

        return {
            isAlive,
            profile,
            sendRequest,
            showSuccess,
            mockQuote
        }
    },
})

</script>

<style scoped lang="scss">
.alert.alert-success {
    margin: 0 2em 2em;
}

.request-button {
    height: 3em;
    padding: 0 1em;
    border-radius: 1.5em;
    background-color: #8dcc7b;

    &:disabled {
        background-color: #ff9595;
        pointer-events: auto;
    }
}

.profile-container {
    display: flex;
    flex-direction: column;
    height: calc(100vh - 2em);

    .content {
        padding: 0 2em 1em;
        flex: 1 1 auto;
        overflow-y: auto;
        border-radius: 0.7em;

        img.profile {
            border-radius: 0.7em;
            width: 100%;
            max-width: 500px;
            margin: 0;
        }

        .quote-container {
            display: flex;
            margin: 3em 0 1.5em;
            justify-content: center;

            .quote {
                height: 2em;

                &:first-of-type {
                    margin-top: -1em;
                    margin-right: 1em;
                }

                &:last-of-type {
                    margin-top: 1em;
                    margin-left: 1em;
                }
            }
        }

        p {
            text-align: left;
        }
    }
}

@media screen and (min-width: 992px) {

    .alert.alert-success {
        margin: 2em 2em 1em;
    }

    .profile-container {
        .content {
            padding-top: 1em;
            display: flex;

            img.profile {
                width: 350px;
                height: fit-content;
            }

            .texts-container {
                padding-left: 4em;
            }
        }

    }
}
</style>